import { select, 
        	json, 
        	geoPath, 
        	geoMercator, 
        	geoOrthographic, 
        	geoStereographic, 
        	geoEquirectangular, 
        	geoNaturalEarth1,
        	geoArmadillo
       } from 'd3';

import { feature } from 'topojson';
//geopath converts dataPath into SVGpath string that we can use in SVG paths
// geoMercator is a map projections

const svg = select('svg');

//const projection = geoOrthographic();
//const projection = geoMercator();
//const projection = geoStereographic();
//const projection = geoEquirectangular();
const projection = geoNaturalEarth1();
//const projection = geoArmadillo();

const pathGenerator = geoPath().projection(projection)
svg.append('path')
	// adding classes
  .attr('class', 'sphere')
	.attr('d', pathGenerator({type: 'Sphere'}));

json('https://unpkg.com/world-atlas@1.1.4/world/110m.json')
	.then(data => {
  	const countries = feature(data, data.objects.countries);
//  	console.log(countries);
  
  	//create a data join
  	// selectAll 'path' then pass in the features
  	const paths = svg.selectAll('path')
    	.data(countries.features);
  	// then append the paths(i.e. shapes to each of the elements)
  	paths.enter().append('path')
  		.attr('class', 'country')
  		.attr('d', d => pathGenerator(d));
  
  //comment: alternate - simplified code 
  //comment: create a data join
  //comment: selectAll 'path' then pass in the features
  // 	svg.selectAll('path').data(countries.features)
  //		.enter().append('path')
  //		.attr('d', pathGenerator);
  // comment: then append the paths(i.e. shapes to each of the elements)
  // comment: pathGenerator does the same thing as d=> pathGenerator(d))	

  
   
});